import pandas as pd
import numpy as np

flnm = input('Data File Name (*.xlsx) = ')
xlsx = pd.ExcelFile(flnm)                   #   入力ファイル名の設定
data = pd.read_excel(xlsx)                  #   読み込み

VarLabels = data.columns[1:].values;
print(VarLabels)

X = data.values[:, 1:]
N = len(X)
M = len(X[0])

S = np.cov(X, rowvar = False)

psy2 = np.zeros((M))
while True:
    C = S - np.diag(psy2)
    w, v = np.linalg.eigh(C)
    A = (w[M-1] ** 0.5) * v[:, M-1]
    t_psy2 = np.diag(S) - A**2
    if (np.abs(psy2 - t_psy2)).sum() < 1.0e-7:
        break
    psy2 = t_psy2

Lmd = (np.diag(S) - psy2) ** 0.5
print()
for i in range(M):
    print(VarLabels[i])
    print('    lambda[{0:}] = {1:.5}'.format(i+1, Lmd[i]))
       
   
sum_L_2 = (Lmd.sum()) ** 2
VarX = np.var(X.sum(axis = 1))
omega = sum_L_2 / VarX
print('\nomega = {0:.5}'.format(omega))

alpha_coef = (M/(M-1)) * (1 - (np.diag(S).sum() / VarX))
print('\nalpha = {0:.5}'.format(alpha_coef))

Cor = np.corrcoef(X, rowvar = False)

r_bar = (Cor.sum() - np.diag(Cor).sum()) / (M * (M - 1))

std_alpha = M * r_bar / (1.0 + (M - 1) * r_bar)
print('standardized alpha = {0:.5}'.format(std_alpha))
